#include <AI8051U.H>
#include <intrins.h>
#include <absacc.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>

#define		RXD		P30
#define		TXD		P31
#define		SCL		P32
#define		SDA		P33
#define		CLK		P34
#define		DAT		P35
#define		FOSC		11059200UL
#define		BAUD		9600UL
#define		BRT			(0x10000-FOSC/BAUD/4)
#define		T_Buf_Len	64		//Uart1ͻ泤
#define		R_Buf_Len	64		//Uart1ջ泤
#define		Master_Addr	0x00	//Uartַ
#define		Slave_Addr	0x01	//Uartӻַ
#define		Broad_Addr	0xFF	//Uart㲥ַ

unsigned char		RP;					//Uart1ָ
unsigned char		TP;					//Uart1ָ
unsigned char		Uart_R_Len;			//Uart1ճ
unsigned char		Uart_T_Len;			//Uart1ͳ
unsigned char xdata	R_Buf[R_Buf_Len];	//Uart1ջ
unsigned char xdata	T_Buf[T_Buf_Len];	//Uart1ͻ
unsigned long		Count;

void UART_Send(unsigned int x)
{
	while(Uart_T_Len);
	TP=0;
	Uart_T_Len=x;
	TI=1;
}

void Uart_Printf(unsigned char *v,...)
{
	va_list ap;
	va_start(ap,v);
	while(Uart_T_Len);
	UART_Send(vsprintf(T_Buf,v,ap));
	va_end(ap);
}

void HX711(void)
{
	unsigned char i;
	CLK=0;
	Count=0;
	_nop_();
	while(DAT);
	for(i=0;i<24;i++)
	{
		CLK=1;
		Count=Count<<1;
		CLK=0;
		if(DAT)
		{
			Count++;
		}
	}
	CLK=1;
	Count=Count^0x800000;
	CLK=0;
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P3M0=0x00;
	P3M1=0x00;
	
	AUXR=0x40;				//öʱ0ʱΪ12Tģʽöʱ1Ϊ1Tģʽöʱ1Ϊʷ
	TMOD=0x01;				//öʱ0Ϊ16λԶװģʽöʱ1Ϊ16λԶװģʽ
	TL0=0x00;				//öʱ0ʼֵ5ms
	TH0=0xEE;				//öʱ0ʼֵ5ms
	TF0=0;					//TF0жϱ־λ
	ET0=1;					//ʹܶʱ0ж
	
	SCON=0x50;				//UART1ģʽΪ8λݿɱ䲨
	TL1=BRT;				//UART1
    TH1=BRT>>8;				//UART1
	TR1=1;					//ʹܶʱ1
	ES=1;					//ʹUART1ж
	
	EA=1;					//ʹж
	
	RP=0;
	TP=0;
	Uart_R_Len=0;
	Uart_T_Len=0;
	memset(R_Buf,0x00,sizeof R_Buf);
	memset(T_Buf,0x00,sizeof T_Buf);
}

void main(void)
{
	float a,b,c,d;
	Init();
	a=8521850ul;
	b=9010000ul;
	c=297.0f;
	while(1)
	{
		HX711();
		d=((float)Count-a)/(b-a)*c;
		Uart_Printf("%08lu %07.2fg\r\n",Count,d);
//		SBUF=d+125;
	}
}

void Uart_Start(void)
{
	TL0=0x00;
	TH0=0xEE;
	TR0=1;
}

void Uart_Stop(void)
{
	TR0=0;
	TL0=0x00;
	TH0=0xEE;
	RP=0;
	memset(R_Buf,0x00,sizeof R_Buf);
	Uart_R_Len=R_Buf_Len;
}

void Timer0_Isr(void) interrupt 1
{
	Uart_Stop();
}

void Uart_Isr(void) interrupt 4
{
	if(RI)
	{
		RI=0;
		Uart_Start();
		R_Buf[RP]=SBUF;
		if(RP==0)
		{
			if(R_Buf[0]==Slave_Addr||R_Buf[0]==Broad_Addr)
			{
				
			}
			else
			{
				Uart_Stop();
			}
		}
		else if(RP==1)
		{
			if(R_Buf[1]==2)
			{
				Uart_R_Len=R_Buf[1]+4;
			}
			else
			{
				Uart_Stop();
			}
		}
		else if(RP==Uart_R_Len-1)
		{
			if((R_Buf[0]==Slave_Addr||R_Buf[0]==Broad_Addr)&&R_Buf[Uart_R_Len-2]==0x0D&&R_Buf[Uart_R_Len-1]==0x0A)
			{
				
			}
			Uart_Stop();
		}
		else if(RP==R_Buf_Len-1)
		{
			Uart_Stop();
		}
		if(TR0)
		{
			RP++;
		}
	}
	if(TI)
	{
		TI=0;
		if(TP==Uart_T_Len)
		{
//			TR=R;
			TP=0;
			Uart_T_Len=0;
		}
		if(Uart_T_Len!=0)
		{
//			TR=T;
			SBUF=(T_Buf[TP]);
			TP++;
		}
	}
}